; script-fu-highlight-text.scm for Gimp 2.10.28: highlights the selected text with yellow background
; Copyright (C) 2021 AlSchemist
; All Rights Reserved.
; Gimp 2.10.28 TinyScheme Script-Fu
; Usage: 1. Select any text.
;        2. Click "Highlight" in the menus at the right of "Help"
; (script-fu-highlight-text (gimp-image-get-id))
(define (script-fu-highlight-text image)
	(if (zero? (car (gimp-selection-bounds image)))
		(error "script-fu-highlight-text needs a selected text!")
		(let*	(	(boundSel   (cdr (gimp-selection-bounds image)))
					(xSel		(car boundSel)) (ySel (cadr boundSel))
					(widthSel	(- (caddr boundSel) xSel))
					(heightSel	(- (cadddr boundSel) ySel))
					(layerHiT	(car (gimp-layer-new image widthSel heightSel RGB-IMAGE "HighlightTxt" 100 LAYER-MODE-MULTIPLY)))
				)
			(gimp-context-push)					(gimp-image-undo-group-start image)
			(gimp-context-set-foreground "#ffff00") ; yellow
			(gimp-layer-add-alpha layerHiT)
			(gimp-drawable-fill layerHiT TRANSPARENT-FILL) 
			(gimp-image-insert-layer image layerHiT 0 -1) ; above the active layer
			(gimp-layer-set-offsets layerHiT xSel ySel)
			(gimp-edit-bucket-fill-full layerHiT BUCKET-FILL-FG 0 100 0 FALSE TRUE 0 0 0)
			(gimp-image-merge-down image layerHiT CLIP-TO-IMAGE)
			(gimp-displays-flush)
			(gimp-selection-none image)
			(gimp-image-undo-group-end image)	(gimp-context-pop)
)	)	)
(script-fu-register "script-fu-highlight-text" "Highlight" "HighlightTxt 1.0" "AlSchemist"
 "2021, AlSchemist" "2021-11-11" "*"
 SF-IMAGE		"image"					0
)
(script-fu-menu-register "script-fu-highlight-text" "<Image>/")
;#| 
;Redistribution and use in source forms, with or without modification,
;are permitted provided that the following conditions are met:
;1. Redistributions of source code must retain:
;   - the copyright notices,
;   - the original URL provided by AlSchemist:
;     http://gimpchat.com/viewtopic.php?f=8&t=19169&p=269570#p269570
;   - this list of conditions and the following disclaimer.
;2. The name of the authors may not be used to endorse or promote products
;   derived from this software without specific prior written permission.
;
;3. This source code cannot be sold.
;
;Unless a specific copyright, credits or URL is specified,
;this free open source code is Copyright (C) AlSchemist (2021).
;All Rights Reserved. Other than personal and noncommercial use is prohibited. 
;
;This software is provided by the authors "as is" and any express or
;implied warranties, including, but not limited to, the implied warranties
;of merchantability and fitness for a particular purpose are disclaimed.
;
;In no event shall the authors be liable for any direct, indirect,
;incidental, special, exemplary, or consequential damages 
;(including, but not limited to, procurement of substitute goods or services;
;loss of use, data, or profits; or business interruption)
;however caused and on any theory of liability, whether in contract, 
;strict liability, or tort (including negligence or otherwise)
;arising in any way out of the use of this software,
;even if advised of the possibility of such damage.
;
;Usage to load again: Gimp menu "Filter" > "Script-Fu" > "Console"
;(load "C:/Users/YourUserName/AppData/Roaming/GIMP/2.10/scripts/script-fu-highlight-text.scm")
; |#
(closure? script-fu-highlight-text)